Attribute VB_Name = "StdDialoge"

' File Open/Save structures and declarations *****************************
Type OPENFILENAME
   lStructSize As Long         'Same
   hwndOwner As Long           'Was Integer
   hInstance As Long           'Was Integer
   lpstrFilter As String       'Was Long
   lpstrCustomFilter As String 'Was Long
   nMaxCustFilter As Long      'Same
   nFilterIndex As Long        'Same
   lpstrFile As String         'Was Long
   nMaxFile As Long            'Same
   lpstrFileTitle As String    'Was Long
   nMaxFileTitle As Long       'Same
   lpstrInitialDir As String   'Was Long
   lpstrTitle As String        'Was Long
   flags As Long               'Same
   nFileOffset As Integer      'Same
   nFileExtension As Integer   'Same
   lpstrDefExt As String       'Was Long
   lCustData As Long           'Same
   lpfnHook As Long            'Same
   lpTemplateName As String    'Was long
End Type

Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Declare Function GetFileTitle Lib "comdlg32.dll" Alias "GetFileTitleA" (ByVal lpszFile As String, ByVal lpszTitle As String, ByVal cbBuf As Integer) As Integer
Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Public Const OFN_ALLOWMULTISELECT = &H200      'See Help Note for LFN Behavior
Public Const OFN_CREATEPROMPT = &H2000
Public Const OFN_ENABLEHOOK = &H20
Public Const OFN_ENABLETEMPLATE = &H40
Public Const OFN_ENABLETEMPLATEHANDLE = &H80
Public Const OFN_EXPLORER = &H80000            'Windows 95 Only
Public Const OFN_EXTENSIONDIFFERENT = &H400
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_LONGNAMES = &H200000          'Windows 95 Only
Public Const OFN_NOCHANGEDIR = &H8
Public Const OFN_NODEREFERENCELINKS = &H100000 'Windows 95 Only
Public Const OFN_NOLONGNAMES = &H40000         'Not Referenced in Help!
Public Const OFN_NONETWORKBUTTON = &H20000
Public Const OFN_NOREADONLYRETURN = &H8000
Public Const OFN_NOTESTFILECREATE = &H10000
Public Const OFN_NOVALIDATE = &H100
Public Const OFN_OVERWRITEPROMPT = &H2
Public Const OFN_PATHMUSTEXIST = &H800
Public Const OFN_READONLY = &H1
Public Const OFN_SHAREAWARE = &H4000
Public Const OFN_SHAREFALLTHROUGH = 2
Public Const OFN_SHARENOWARN = 1
Public Const OFN_SHAREWARN = 0
Public Const OFN_SHOWHELP = &H10

'ChooseColor structure and function declarations *************************

Type CHOOSECOLOR
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        rgbResult As Long
        lpCustColors As Long
        flags As Long
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type

Declare Function CHOOSECOLOR Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As CHOOSECOLOR) As Long

Public Const CC_ENABLEHOOK = &H10
Public Const CC_ENABLETEMPLATE = &H20
Public Const CC_ENABLETEMPLATEHANDLE = &H40
Public Const CC_FULLOPEN = &H2
Public Const CC_PREVENTFULLOPEN = &H4
Public Const CC_RGBINIT = &H1
Public Const CC_SHOWHELP = &H8

' FONT STUFF
Global Const LF_FACESIZE = 32

Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName(LF_FACESIZE) As Byte
End Type

Global Const LOGPIXELSY = 90    '  Logical pixels/inch in Y
Public Const CCHDEVICENAME = 32
Public Const CCHFORMNAME = 32

Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long

'ChooseFont structure and function declarations *************************

Type ChooseFont
        lStructSize As Long
        hwndOwner As Long          '  caller's window handle
        hDC As Long                '  printer DC/IC or NULL
        lpLogFont As Long          '  ptr. to a LOGFONT struct
        iPointSize As Long         '  10 * size in points of selected font
        flags As Long              '  enum. type flags
        rgbColors As Long          '  returned text color
        lCustData As Long          '  data passed to hook fn.
        lpfnHook As Long           '  ptr. to hook function
        lpTemplateName As String   '  custom template name
        hInstance As Long          '  instance handle of.EXE that
                                   '    contains cust. dlg. template
        lpszStyle As String        '  return the style field here
                                   '  must be LF_FACESIZE or bigger
        nFontType As Integer       '  same value reported to the EnumFonts
                                   '    call back with the extra FONTTYPE_
                                   '    bits added
        MISSING_ALIGNMENT As Integer
        nSizeMin As Long           '  minimum pt size allowed &
        nSizeMax As Long           '  max pt size allowed if
                                   '    CF_LIMITSIZE is used
End Type

Declare Function ChooseFont Lib "comdlg32.dll" Alias "ChooseFontA" (pChoosefont As ChooseFont) As Long
'Declare Function VarPtr Lib "VB40032" (lpVoid As Any) As Long 'Secret VB Runtime function
Declare Function VarPtr Lib "MSVBVM50.DLL" (lpVoid As Any) As Long 'Secret VB Runtime function

Public Const CF_ANSIONLY = &H400&
Public Const CF_APPLY = &H200&
Public Const CF_EFFECTS = &H100&
Public Const CF_ENABLEHOOK = &H8&
Public Const CF_ENABLETEMPLATE = &H10&
Public Const CF_ENABLETEMPLATEHANDLE = &H20&
Public Const CF_FIXEDPITCHONLY = &H4000&
Public Const CF_FORCEFONTEXIST = &H10000
Public Const CF_INITTOLOGFONTSTRUCT = &H40&
Public Const CF_LIMITSIZE = &H2000&
Public Const CF_NOFACESEL = &H80000
Public Const CF_NOSCRIPTSEL = &H800000
Public Const CF_NOSIMULATIONS = &H1000&
Public Const CF_NOSIZESEL = &H200000
Public Const CF_NOSTYLESEL = &H100000
Public Const CF_NOVECTORFONTS = &H800&
Public Const CF_NOVERTFONTS = &H1000000
Public Const CF_OWNERDISPLAY = &H80
Public Const CF_PRINTERFONTS = &H2
Public Const CF_SCALABLEONLY = &H20000
Public Const CF_SCREENFONTS = &H1
Public Const CF_SCRIPTSONLY = CF_ANSIONLY
Public Const CF_SELECTSCRIPT = &H400000
Public Const CF_SHOWHELP = &H4&
Public Const CF_TTONLY = &H40000
Public Const CF_USESTYLE = &H80&
Public Const CF_WYSIWYG = &H8000
Public Const CF_BOTH = (CF_SCREENFONTS Or CF_PRINTERFONTS)
Public Const CF_NOOEMFONTS = CF_NOVECTORFONTS

Global Const SIMULATED_FONTTYPE = &H8000
Global Const PRINTER_FONTTYPE = &H4000
Global Const SCREEN_FONTTYPE = &H2000
Global Const BOLD_FONTTYPE = &H100
Global Const ITALIC_FONTTYPE = &H200
Global Const REGULAR_FONTTYPE = &H400

Global Const WM_CHOOSEFONT_GETLOGFONT = (&H400 + 1) 'WM_USER + 1

Global Const LBSELCHSTRING = "commdlg_LBSelChangedNotify"
Global Const SHAREVISTRING = "commdlg_ShareViolation"
Global Const FILEOKSTRING = "commdlg_FileNameOK"
Global Const COLOROKSTRING = "commdlg_ColorOK"
Global Const SETRGBSTRING = "commdlg_SetRGBColor"
Global Const FINDMSGSTRING = "commdlg_FindReplace"
Global Const HELPMSGSTRING = "commdlg_help"

Global Const CD_LBSELNOITEMS = -1
Global Const CD_LBSELCHANGE = 0
Global Const CD_LBSELSUB = 1
Global Const CD_LBSELADD = 2


'Printer related structures and function declarations ********************

Type PRINTDLG
        lStructSize As Long
        hwndOwner As Long
        hDevMode As Long
        hDevNames As Long
        hDC As Long
        flags As Long
        nFromPage As Integer
        nToPage As Integer
        nMinPage As Integer
        nMaxPage As Integer
        nCopies As Integer
        hInstance As Long
        lCustData As Long
        lpfnPrintHook As Long
        lpfnSetupHook As Long
        lpPrintTemplateName As String
        lpSetupTemplateName As String
        hPrintTemplate As Long
        hSetupTemplate As Long
End Type

Declare Function PRINTDLG Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As PRINTDLG) As Long

Global Const PD_ALLPAGES = &H0
Global Const PD_SELECTION = &H1
Global Const PD_PAGENUMS = &H2
Global Const PD_NOSELECTION = &H4
Global Const PD_NOPAGENUMS = &H8
Global Const PD_COLLATE = &H10
Global Const PD_PRINTTOFILE = &H20
Global Const PD_PRINTSETUP = &H40
Global Const PD_NOWARNING = &H80
Global Const PD_RETURNDC = &H100
Global Const PD_RETURNIC = &H200
Global Const PD_RETURNDEFAULT = &H400
Global Const PD_SHOWHELP = &H800
Global Const PD_ENABLEPRINTHOOK = &H1000
Global Const PD_ENABLESETUPHOOK = &H2000
Global Const PD_ENABLEPRINTTEMPLATE = &H4000
Global Const PD_ENABLESETUPTEMPLATE = &H8000
Global Const PD_ENABLEPRINTTEMPLATEHANDLE = &H10000
Global Const PD_ENABLESETUPTEMPLATEHANDLE = &H20000
Global Const PD_USEDEVMODECOPIES = &H40000
Global Const PD_DISABLEPRINTTOFILE = &H80000
Global Const PD_HIDEPRINTTOFILE = &H100000

Type DEVNAMES
    wDriverOffset As Integer
    wDeviceOffset As Integer
    wOutputOffset As Integer
    wDefault As Integer
   Strg As String * 256
End Type
Global DN As DEVNAMES

Global Const DN_DEFAULTPRN = &H1

'retrieves error value

Declare Function CommDlgExtendedError Lib "comdlg32.dll" () As Long

'************************* end of Common Dialogs Declares ************

' GLOBAL MEMORY Stuff

Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long

Global Const GMEM_MOVEABLE = &H2
Global Const GMEM_ZEROINIT = &H40
Global Const GHND = (GMEM_MOVEABLE Or GMEM_ZEROINIT)

Declare Sub MemoryCopy Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal dwBytes As Long)

'PRINTER stuff

Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long

Type DEVMODE
        dmDeviceName As String * CCHDEVICENAME
        dmSpecVersion As Integer
        dmDriverVersion As Integer
        dmSize As Integer
        dmDriverExtra As Integer
        dmFields As Long
        dmOrientation As Integer
        dmPaperSize As Integer
        dmPaperLength As Integer
        dmPaperWidth As Integer
        dmScale As Integer
        dmCopies As Integer
        dmDefaultSource As Integer
        dmPrintQuality As Integer
        dmColor As Integer
        dmDuplex As Integer
        dmYResolution As Integer
        dmTTOption As Integer
        dmCollate As Integer
        dmFormName As String * CCHFORMNAME
        dmUnusedPadding As Integer
        dmBitsPerPel As Integer
        dmPelsWidth As Long
        dmPelsHeight As Long
        dmDisplayFlags As Long
        dmDisplayFrequency As Long
End Type

Global DV As DEVMODE
Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long

Function Dialog_Append$(f As Form, ByVal ftitle$, fpfad$, ByVal ffile$, ByVal ffilter$, ByVal fext$)

Dialog_Append$ = DialogOpenSave$(f, ftitle$, fpfad$, ffile$, ffilter$, fext$, 2)

End Function

Function Dialog_Color%(f As Form, CurrColor&)

Dim c As CHOOSECOLOR
Dim Address As Long
Dim Memhandle As Long, wSize As Long

ReDim ClrArray(15) As Long    ' Holds Custom Colors

wSize = Len(ClrArray(0)) * 16 ' Size of Memory Block

Memhandle = GlobalAlloc(GHND, wSize)
If Memhandle = 0 Then Dialog_Color% = False: Exit Function
Address = GlobalLock(Memhandle)

For i& = 0 To UBound(ClrArray): ClrArray(i&) = &HFFFFFF: Next

Call MemoryCopy(ByVal Address, ClrArray(0), wSize)

c.lStructSize = Len(c)
c.hwndOwner = f.hwnd
c.lpCustColors = Address
c.rgbResult = CurrColor&
c.flags = CC_RGBINIT Or CC_FULLOPEN

result = CHOOSECOLOR(c)

Call MemoryCopy(ClrArray(0), ByVal Address, wSize)

ok = GlobalUnlock(Memhandle)    'Free The Memory
ok = GlobalFree(Memhandle)

If result = 0 Then Dialog_Color% = False: Exit Function

CurrColor& = c.rgbResult

Dialog_Color% = True

End Function

Function Dialog_Font%(f As Form, ffont$, fsize%, fstyle$, ByVal fFlags&)

Dim a As ChooseFont
Dim LF As LOGFONT
Dim Address As Long
Dim Memhandle As Long
Dim FaceNameString As String
Dim result As Long

LF.lfHeight = fsize% / (72 / GetDeviceCaps(f.hDC, LOGPIXELSY)) * -1
If InStr(fstyle$, "f") Then LF.lfWeight = 700 Else LF.lfWeight = 300
If InStr(fstyle$, "i") Then LF.lfItalic = 1
If InStr(fstyle$, "s") Then LF.lfStrikeOut = 1
If InStr(fstyle$, "u") Then LF.lfUnderline = 1
Call MemoryCopy(LF.lfFaceName(0), ByVal ffont$, LF_FACESIZE)

a.lpLogFont = VarPtr(LF)

a.hDC = f.hDC
a.lStructSize = Len(a)
a.hwndOwner = f.hwnd
a.flags = fFlags& Or CF_INITTOLOGFONTSTRUCT 'CF_SCREENFONTS Or CF_EFFECTS
a.nFontType = SCREEN_FONTTYPE
a.rgbColors = 0&

result = ChooseFont(a)

FaceNameString = StrConv(LF.lfFaceName, vbUnicode) 'Convert to string from byte array
If result = 0 Then Dialog_Font% = False: Exit Function
        
fsize% = Abs(LF.lfHeight * (72 / GetDeviceCaps(f.hDC, LOGPIXELSY)))
ffont$ = Left$(FaceNameString, InStr(FaceNameString, Chr$(0)) - 1)

fstyle$ = ""
If LF.lfWeight >= 500 Then fstyle$ = fstyle$ + "f"
If LF.lfItalic Then fstyle$ = fstyle$ + "i"
If LF.lfStrikeOut Then fstyle$ = fstyle$ + "s"
If LF.lfUnderline Then fstyle$ = fstyle$ + "u"
    
'.. = A.rgbColors

Dialog_Font% = True


'On Error Resume Next
'
'F.CommonDialog.CancelError = True
'
'F.CommonDialog.FontBold = InStr(fstyle$, "f") > 0
'F.CommonDialog.FontItalic = InStr(fstyle$, "i") > 0
'F.CommonDialog.FontStrikethru = InStr(fstyle$, "s") > 0
'F.CommonDialog.FontUnderline = InStr(fstyle$, "u") > 0
'F.CommonDialog.FontName = ffont$
'F.CommonDialog.FontSize = fsize%
'
'F.CommonDialog.flags = fFlags& Or CF_INITTOLOGFONTSTRUCT 'CF_SCREENFONTS+Or CF_EFFECTS
'F.CommonDialog.ShowFont
'
'If Err Then
'   Dialog_Font% = False
'Else
'   fstyle$ = ""
'   If F.CommonDialog.FontBold Then fstyle$ = fstyle$ + "f"
'   If F.CommonDialog.FontItalic Then fstyle$ = fstyle$ + "i"
'   If F.CommonDialog.FontStrikethru Then fstyle$ = fstyle$ + "s"
'   If F.CommonDialog.FontUnderline Then fstyle$ = fstyle$ + "u"
'   ffont$ = F.CommonDialog.FontName
'   fsize% = F.CommonDialog.FontSize
'   Dialog_Font% = True
'End If

End Function


Function Dialog_Open$(f As Form, ByVal ftitle$, fpfad$, ByVal ffile$, ByVal ffilter$, ByVal fext$)

Dialog_Open$ = DialogOpenSave$(f, ftitle$, fpfad$, ffile$, ffilter$, fext$, 0)

End Function

Function Dialog_Printer%(f As Form, fhdc&, fmark%, fmin%, fmax%, fab%, fbis%)

Dim Address As Long
Dim p As PRINTDLG
Dim D As DEVMODE
Dim Memhandle As Long, wSize As Long

pflag& = PD_HIDEPRINTTOFILE Or PD_USEDEVMODECOPIES Or PD_RETURNDC
If fmark% <> 0 Then pflag& = pflag& Or PD_SELECTION Else pflag& = pflag& Or PD_NOSELECTION
If fmax% > 1 And fmark% = 0 And (fab% > fmin% Or fbis% < fmax%) Then pflag& = pflag& Or PD_PAGENUMS
If fmax% <= 1 Then pflag& = pflag& Or PD_NOPAGENUMS
If fmark% < 0 Then pflag& = pflag& Or PD_PRINTSETUP

p.lStructSize = Len(p)
p.hwndOwner = hwnd
p.flags = pflag& 'PD_RETURNIC
p.nFromPage = fab%
p.nToPage = fbis%
p.nMinPage = fmin%
p.nMaxPage = fmax%
p.nCopies = 1
result = PRINTDLG(p)

If result = 0 Then Dialog_Printer% = False: Exit Function

If p.hDC <> 0 Then ok = DeleteDC(p.hDC)
If p.hDevNames <> 0 Then ok = GlobalFree(p.hDevNames)

Address = GlobalLock(p.hDevMode)
Call MemoryCopy(D, ByVal Address, Len(D))
ok = GlobalUnlock(p.hDevMode)
ok = GlobalFree(p.hDevMode)

'Print "Printer:", Left$(D.dmDeviceName, InStr(D.dmDeviceName, Chr$(0)) - 1)
'Print "Copies:", P.nCopies

fhdc& = p.hDC
fmark% = p.flags And PD_SELECTION
If p.flags And PD_PAGENUMS Then
   fab% = p.nFromPage
   fbis% = p.nToPage
Else
   fbis% = fmax%
   fab% = fmin%
End If
Dialog_Printer% = True

End Function


Sub Dialog_PrinterSetup(f As Form, fhdc%)
    
Dim Address As Long
Dim p As PRINTDLG
Dim D As DEVMODE
Dim Memhandle As Long, wSize As Long

p.lStructSize = Len(p)
p.hwndOwner = f.hwnd
p.flags = PD_PRINTSETUP
result = PRINTDLG(p)

If result = 0 Then Exit Sub

If p.hDC <> 0 Then ok = DeleteDC(p.hDC)
If p.hDevNames <> 0 Then ok = GlobalFree(p.hDevNames)

Address = GlobalLock(p.hDevMode)
Call MemoryCopy(D, ByVal Address, Len(D))

ok = GlobalUnlock(p.hDevMode) 'free the memory
ok = GlobalFree(p.hDevMode)

'Print "Printer:", Left$(D.dmDeviceName, InStr(D.dmDeviceName, Chr$(0)) - 1)
'Print "Orientation:", D.dmOrientation

End Sub

Function Dialog_Save$(f As Form, ByVal ftitle$, fpfad$, ByVal ffile$, ByVal ffilter$, ByVal fext$)

Dialog_Save$ = DialogOpenSave$(f, ftitle$, fpfad$, ffile$, ffilter$, fext$, 1)

End Function

Function DialogOpenSave$(f As Form, ByVal ftitle$, fpfad$, ByVal ffile$, ByVal ffilter$, ByVal fext$, SaveFile%)

Dim O As OPENFILENAME
Dim wSize As Long
Dim Memhandle As Long

szFile$ = ffile$ + String$(128 - Len(ffile$), 0)
szFilter$ = ffilter$ + "||": ersetze szFilter$, "|", Chr$(0)

O.lStructSize = Len(O)
O.hwndOwner = f.hwnd
O.nFilterIndex = 1
O.nMaxFile = Len(szFile$)

Select Case SaveFile%
Case 0: O.flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST Or OFN_FILEMUSTEXIST
Case 1: O.flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST Or OFN_OVERWRITEPROMPT
Case 2: O.flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
End Select

O.lpstrFile = szFile$
O.lpstrFilter = szFilter$
O.lpstrTitle = ftitle$
O.lpstrDefExt = fext$
O.lpstrInitialDir = fpfad$

dr$ = CurDir$

If SaveFile% = 0 Then result = GetOpenFileName(O) Else result = GetSaveFileName(O)

file$ = Left$(O.lpstrFile, InStr(O.lpstrFile, Chr$(0)) - 1)

If result = 0 Then
   DialogOpenSave$ = ""
Else
   fpfad$ = Left$(file$, O.nFileOffset)
   DialogOpenSave$ = Right$(file$, Len(file$) - O.nFileOffset)
End If

'
'On Error Resume Next'
'
'F.CommonDialog.CancelError = True
'F.CommonDialog.DefaultExt = fext$
'F.CommonDialog.filename = vorpfad$(fpfad$) + ffile$
'F.CommonDialog.Filter = ffilter$
'F.CommonDialog.FilterIndex = 1
'
'F.CommonDialog.DialogTitle = ftitle$
'
'Select Case SaveFile%
'Case 0: F.CommonDialog.flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST Or OFN_FILEMUSTEXIST
'        F.CommonDialog.ShowOpen
'Case 1: F.CommonDialog.flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST Or OFN_OVERWRITEPROMPT
'        F.CommonDialog.ShowSave
'Case 2: F.CommonDialog.flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
'        F.CommonDialog.ShowSave
'End Select
'
'If Err Then
'   DialogOpenSave$ = ""
'Else
'   fpfad$ = get_pfad$(F.CommonDialog.filename)
'   DialogOpenSave$ = get_file$(F.CommonDialog.filename)
'End If'
'

ChDrive Left$(dr$, 2)
ChDir dr$

End Function

Sub ersetze(a$, von$, nach$)

If Len(von$) = 0 Then Exit Sub

pos% = 0
Do
   pos% = InStr(pos% + 1, a$, von$): If pos% = 0 Then Exit Do
   a$ = Left$(a$, pos% - 1) + nach$ + Mid$(a$, pos% + Len(von$))
   pos% = pos% + Len(nach$) - 1
Loop

End Sub

Function tempfile$()

a$ = Space$(144)
pfd$ = Environ$("tmp")
If pfd$ = "" Then pfd$ = Environ$("temp")
If pfd$ = "" Then pfd$ = "."
z& = GetTempFileName(pfd$, "bp", 0, a$)   '#notranslate
tempfile$ = Left$(a$, InStr(a$, Chr$(0)) - 1)

End Function

