VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TelnetScript"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Public Connected As Boolean

Private WithEvents myTelnet As Telnet
Attribute myTelnet.VB_VarHelpID = -1
Private zeile$, waitforstring$
Private Declare Sub SleepMillisec Lib "kernel32" Alias "Sleep" (ByVal dwMilliseconds As Long)

Private Sub Class_Initialize()

Set myTelnet = New Telnet
myTelnet.Terminal = "terminet"
Connected = False

End Sub

Private Sub Class_Terminate()

Disconnect
Set myTelnet = Nothing

End Sub

Public Function Connect(Host$) As Boolean

If Connected Then Connect = False: Exit Function
 
zeile$ = "": waitforstring$ = ""

If Not myTelnet.Connect(Host$) Then
   Debug.Print "ERROR: cannot connect to " + Host$
   Connect = False
Else
   Connect = True
End If

End Function

Public Sub Disconnect()

If Not Connected Then Debug.Print "ERROR: not connected (Disconnect)": Exit Sub

myTelnet.Disconnect
Connected = False

End Sub

Public Sub WaitFor(par$)

If Not Connected Then Debug.Print "ERROR: not connected (WaitFor)": Exit Sub

'Debug.Print "...WAITFOR "; par$
waitforstring$ = par$
Do While Len(waitforstring$) > 0 And Connected = True: DoEvents: Loop

End Sub

Public Sub send(par$)

If Not Connected Then Debug.Print "ERROR: not connected (Send)": Exit Sub

'Debug.Print "...SEND "; par$
myTelnet.SendData par$ + vbCrLf

End Sub

Public Sub Sleep(sec As Double)

SleepMillisec sec * 1000

End Sub

Private Sub myTelnet_CharArrival(ch As Byte)

If ch = 10 Then
   Debug.Print zeile$
   zeile$ = ""
ElseIf ch >= 32 Then
   zeile$ = zeile$ + Chr$(ch)
   If Right$(zeile$, Len(waitforstring$)) = waitforstring$ Then waitforstring$ = ""
End If

End Sub

Private Sub myTelnet_Closed()

Connected = False

End Sub

Private Sub myTelnet_Connected(Host As String)

Connected = True

End Sub
