VERSION 5.00
Begin VB.Form frmTelnet 
   Caption         =   "Telnet Client"
   ClientHeight    =   4830
   ClientLeft      =   -210
   ClientTop       =   3015
   ClientWidth     =   6390
   FillColor       =   &H00800000&
   BeginProperty Font 
      Name            =   "Terminal"
      Size            =   9
      Charset         =   255
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   Icon            =   "TelnetSimple.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'ZReihenfolge
   ScaleHeight     =   4830
   ScaleWidth      =   6390
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.TextBox TextTelnet 
      Height          =   3855
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Beides
      TabIndex        =   0
      Top             =   0
      Width           =   5295
   End
   Begin VB.Menu menu_verbindung 
      Caption         =   "&Verbindung"
      Begin VB.Menu menu_connect 
         Caption         =   "&ffnen"
         Shortcut        =   ^O
      End
      Begin VB.Menu menu_disconnect 
         Caption         =   "&Schlieen"
         Enabled         =   0   'False
      End
      Begin VB.Menu menu_v1 
         Caption         =   "-"
      End
      Begin VB.Menu menu_ende 
         Caption         =   "&Beenden"
      End
   End
End
Attribute VB_Name = "frmTelnet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private WithEvents myTelnet As Telnet
Attribute myTelnet.VB_VarHelpID = -1
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Server$
Private data$

Private Sub Form_Load()

Server$ = ini$("Server")

Set myTelnet = New Telnet
myTelnet.Terminal = "terminet" '"network"
myTelnet.Trace = True

''login at startup
'myTelnet.Connect server$

End Sub

Private Sub Form_Resize()

If Me.WindowState = 1 Then Exit Sub
TextTelnet.Width = Me.ScaleWidth
TextTelnet.Height = Me.ScaleHeight

End Sub

Private Sub Form_Unload(Cancel As Integer)

Set myTelnet = Nothing

End Sub

Private Sub menu_disconnect_Click()

myTelnet.Disconnect

End Sub

Private Sub menu_ende_Click()

Unload Me

End Sub

Private Sub menu_connect_Click()

Host$ = InputBox$("Host", "Verbindung ffnen", Server$)
If Host$ = "" Then Exit Sub
Server$ = Host$

data$ = ""
TextTelnet.Text = ""

Screen.MousePointer = 11
myTelnet.Connect Host$
Screen.MousePointer = 0

End Sub

Private Sub myTelnet_CharArrival(ch As Byte)

If ch >= 32 Then
   data$ = data$ + Chr$(ch)
ElseIf ch = 10 Then
   data$ = data$ + vbCrLf
ElseIf ch = 8 And Len(data$) > 0 Then
   data$ = Left$(data$, Len(data$) - 1)
End If

End Sub

Private Sub myTelnet_Connected(Host As String)

menu_connect.Enabled = False
menu_disconnect.Enabled = True
Me.Caption = "Telnet Client - " + Host

End Sub

Private Sub myTelnet_Closed()

menu_connect.Enabled = True
menu_disconnect.Enabled = False
Me.Caption = "Telnet Client"

End Sub

Function ini$(key$)

Dim a As String * 255
l& = GetPrivateProfileString("Telnet", key$, "", a$, 255, App.Path + "\config.ini")
ini$ = Left$(a$, l&)

End Function

Private Sub Form_KeyPress(KeyAscii As Integer)

If KeyAscii > 0 Then
   myTelnet.SendData Chr$(KeyAscii)
End If
KeyAscii = 0

End Sub

Private Sub myTelnet_Cursor(visible As Boolean)

If visible Then
   If Len(data$) > 10000 Then data$ = Mid$(data$, Len(data$) - 10000)
   TextTelnet.Text = data$
   TextTelnet.SelStart = Len(data$)
End If

End Sub
